import networkx as nx
from queue import PriorityQueue

def Best_First_Search(G: nx.Graph, start, end,f):
    """A greedy, algorithm that uses a min PriorityQueue and a hueristic (approximation) function f to 
    rank nodes and then traverse them."""

    #Initialize PriorityQueue and path list
    Q = PriorityQueue()
    path = []

    #Add the start node, with it's priority evauluated by f
    Q.put((f(start),start))

    #While there is some node left to check, add it to path and 
    while not Q.empty():
        cwn = Q.get()[1]
        path.append(cwn)
        #Get all neighbours
        for successor in list(G.adj[cwn]):
            if successor == end:
                path.append(end)
                return path
            #If a neighbour is unvisited & unprocessed, add it to PQueue
            elif not (successor in path or successor in Q.queue):
                Q.put((f(successor),successor))
    return False